import { json } from "@sveltejs/kit";
import type { RequestHandler } from "./$types";
import { putObject } from "$lib/helpers/minio";
import { generateImage } from "$lib/helpers/stability";

export const POST: RequestHandler = async ({ params, request }) => {

  const inputName = params.name;
  if (!inputName) {
    throw new Error("Missing name");
  }
  if (inputName.length > 50) {
    throw new Error("Name too long");
  }

  const { hairType, hairColor, hairLength } = await request.json();
  console.log(hairType, hairColor, hairLength)

  if (!hairType || !hairColor || !hairLength) {
    throw new Error("Missing hairType, hairColor or hairLength");
  }

  const prompt = `realistic portrait oil painting of a masked ${inputName}, baroque, in the style of Charles Vess, masked ball attire, opulence, mystery, elegance, ${hairLength} ${hairType} ${hairColor} hair, darker skin`;
  const negativePrompt = "blurry, multiple persons, picture frame"

  const a = performance.now()
  // #const image = await openai.image(prompt);
  const image = await generateImage(prompt, negativePrompt);
  const duration = performance.now() - a;


  const imageName = `${Math.random().toString(16).substring(3, 10)}-${inputName.toLowerCase().split(" ").slice(0, 5).join("-").slice(0, 25)}.png`

  await putObject(imageName, Buffer.from(image.base64, 'base64'), { "Content-Type": "image/png" });

  return json({
    duration,
    url: `https://s3-api.app.max-richter.dev/silvester23/${imageName}`
  })
}
